Subject: Re: [PATCH] PowerPC: MPIC ack interrupts at mpic_teardown_this_cpu()

From: Olof Johansson <[email-masked]>
Date: Fri, 4 Apr 2008 00:29:55 -0500

On Fri, Apr 04, 2008 at 08:50:36AM +1100, Benjamin Herrenschmidt wrote:
> 
> On Thu, 2008-04-03 at 23:09 +0400, Valentine Barshak wrote:
> > We really need to ack interrupts at mpic_teardown, since
> > not all platforms reset mpic at kernel start-up. For example,
> > kexec'ed kernel hangs on P.A. Semi if mpic_eoi() isn't called.
> > 
> > Signed-off-by: Valentine Barshak <[email-masked]>
> > ---
> 
> Would be interesting to find out why it hangs tho... it shouldn't .

I haven't reproduced the problem and looked at hardware state yet, but I
would expect it to be because the openpic won't send another interrupt
until the previous is EOI'd, and the IPI is never EOI'd as far as I
can tell.

The XICS code does it explicitly already. I'm surprised it doesn't break
on the 970-based platforms actually...

-Olof